use std::str;

pub fn parse_hex_string(input: &String) -> [u8; 16] {
    let mut result = [0u8; 16];
    // Iterate over the string 2 characters each time
    for (index, byte) in input.as_bytes().chunks(2).enumerate() {
        if let Ok(byte_str) = str::from_utf8(byte) {
            if let Ok(byte_value) = u8::from_str_radix(byte_str, 16) {
                result[index] = byte_value;
            } else {
                panic!("Failed to parse byte");
            }
        } else {
            panic!("Invalid byte string");
        }
    }
    result
}

pub fn string_to_u8_16(input: &String) -> [u8; 16] {
    let mut result = [0u8; 16];
    let bytes = input.as_bytes();
    let len = bytes.len().min(16);
    result[..len].copy_from_slice(&bytes[..len]);
    result
}

pub fn u8_16_to_string(input: &[u8; 16]) -> String {
    let slice = &input[..];
    let string = str::from_utf8(slice).expect("Invalid UTF-8");
    string.to_string()
}
